name: oci-linux-config
Version: 2.0
Release: 1.0.14%{?dist}
Summary: Configuration tasks for Linux instances running in Oracle Cloud Infrastructure

BuildRequires: make
BuildRequires: selinux-policy-devel
BuildRequires: selinux-policy-targeted
BuildArch: noarch

Group: Development/Tools
URL: http://cloud.oracle.com/iaas
License: GPLv2+
Vendor: Oracle

Source: %{name}-%{version}.tar.gz
Patch0001: 0001-Disable-ssh-pwauth-in-99_oci-cfg.patch
Patch0002: 0002-oci-dhclient-selinux-policy.patch
Patch0003: 0003-oci-pcp-selinux-policy.patch
Patch0004: 0004-oci-dhclient-hostname-removal.patch
Patch0005: 0005-udev-changes-to-update-max-retries.patch
Patch0006: 0006-Adjust-cron-times-for-uptrack-ksplice.patch
Patch0007: 0007-yum-repo-mapper-self-service-DNS.patch
Patch0008: 0008-passwd-mgmt-line-reorder.patch
Patch0009: 0009-multipath-persistent-naming.patch
Patch0010: 0010-ldconfig-unmask-and-enable.patch
Patch0011: 0011-update-iscsi-args-drop-initramfs-modules.patch
Patch0012: 0012-fix-service-file-typo.patch
Patch0013: 0013-skip-minimal-grubby-iscsi-updates.patch
Patch0014: 0014-revert-optimization-updates.patch
Patch0015: 0015-cmdline-iscsi-args-update.patch
Patch0016: 0016-oci-dhclient-dhcpc_t-selinux-policy.patch

# Add rpm to enable ignore-carrier option:
Requires: NetworkManager-config-server

%description
This package contains configuration tasks for Linux instances running in Oracle Cloud Infrastructure environment

%prep
%autosetup -p1

%build
cd install%{_prefix}/lib/%{name}/
make -f /usr/share/selinux/devel/Makefile oci-dhclient.pp
make -f /usr/share/selinux/devel/Makefile oci-pcp.pp
rm -rf tmp

%install
rm -rf %{buildroot}/*
cp -a install/*  %{buildroot}

rm -f %{buildroot}/usr/lib/%{name}/oci-dhclient.te
rm -f %{buildroot}/usr/lib/%{name}/oci-dhclient.fc
rm -f %{buildroot}/usr/lib/%{name}/oci-dhclient.if
rm -f %{buildroot}/usr/lib/%{name}/oci-pcp.te
rm -f %{buildroot}/usr/lib/%{name}/oci-pcp.fc
rm -f %{buildroot}/usr/lib/%{name}/oci-pcp.if

%files
#dracut
%attr(644,root,root) %{_prefix}/lib/dracut/dracut.conf.d/99-oci.conf
#yum repo mapper
%attr(644,root,root) %{_prefix}/lib/systemd/system/oci-yum-repo-mapper.service
%attr(755,root,root) %{_sbindir}/oci-yum-repo-mapper
#logrotate
%attr(644,root,root) %{_sysconfdir}/logrotate.d/%{name}
#rsyslog
%attr(644,root,root) %{_sysconfdir}/rsyslog.d/10-oci.conf
#pwquality
%attr(644,root,root) %{_sysconfdir}/security/pwquality.conf.d/99-oci.conf
#iscsi
%dir %attr(700,root,root) %{_sharedstatedir}/iscsi/nodes/iqn.2015-02.oracle.boot:uefi/
%dir %attr(700,root,root) %{_sharedstatedir}/iscsi/nodes/iqn.2015-02.oracle.boot:uefi/169.254.0.2,3260,1
%attr(600,root,root) %{_sharedstatedir}/iscsi/nodes/iqn.2015-02.oracle.boot:uefi/169.254.0.2,3260,1/default
%attr(755,root,root) %{_sbindir}/iscsi-boot-volume
%dir %{_prefix}/lib/%{name}
%dir %{_prefix}/lib/%{name}/cloud/scripts/per-instance
%dir %{_prefix}/lib/%{name}/cloud/scripts/per-boot
%attr(644,root,root) %{_prefix}/lib/systemd/system/iscsi-boot-volume.service
#dhclient/hostname
%dir %{_sysconfdir}/dhcp/dhclient.d/
%attr(755,root,root) %{_sysconfdir}/dhcp/dhclient.d/oci.sh
%attr(755,root,root) %{_prefix}/lib/%{name}/oci-dhclient.sh
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/oci-hostname.conf
#oci-dhclient specific selinux module
%attr(755,root,root) %{_prefix}/lib/%{name}/oci-dhclient.pp
#oci-pcp specific selinux module
%attr(755,root,root) %{_prefix}/lib/%{name}/oci-pcp.pp
%attr(500,root,root) %{_prefix}/lib/%{name}/olc_selinux_update.sh
#udev
%attr(644,root,root) %{_prefix}/lib/udev/rules.d/99-systemoci-persistent-names.rules
%attr(644,root,root) %{_prefix}/lib/udev/rules.d/99-systemoci-device.rules
%attr(755,root,root) %{_prefix}/lib/udev/ociudevpersistentnaming
%attr(755,root,root) %{_prefix}/lib/udev/updateocideviceparameters
%attr(755,root,root) %{_prefix}/lib/%{name}/updatemaxretries.sh
#systemd preset
%attr(644,root,root) %{_prefix}/lib/systemd/system-preset/84-oci-ol-image.preset
#fstab note update
%attr(755,root,root) %{_prefix}/lib/%{name}/fstab_note.sh
#iscsid.conf update
%attr(755,root,root) %{_prefix}/lib/%{name}/iscsid_conf_update.sh
#password management
%attr(500,root,root) %{_prefix}/lib/%{name}/passwd_mgmt.sh
#misc
%attr(500,root,root) %{_prefix}/lib/%{name}/misc_updates.sh
#cloud-init
%attr(500, root, root) %{_prefix}/lib/%{name}/cloud/scripts/per-instance/oci.sh
%attr(500, root, root) %{_prefix}/lib/%{name}/cloud/scripts/per-boot/oci.sh
#sysctl
%attr(644,root,root) %config(noreplace) %{_prefix}/lib/sysctl.d/50-ipv6.conf
%attr(644,root,root) %{_prefix}/lib/sysctl.d/50-scsi-logging.conf
#cloud-init
%attr(644,root,root) %{_sysconfdir}/cloud/cloud.cfg.d/99_oci.cfg
%dir %{_sharedstatedir}/cloud/scripts/per-instance
%dir %{_sharedstatedir}/cloud/scripts/per-boot
# nfs_client_id service
%attr(644,root,root) %{_prefix}/lib/systemd/system/nfs_client_id.service
%attr(755,root,root) %{_prefix}/libexec/nfs_client_id

%license LICENSE

%post
# ksplice: Enable ksplice
%{_prefix}/lib/%{name}/misc_updates.sh || :

# iSCSI: Increase iSCSI timeout interval and disable NOP-Outs
%{_prefix}/lib/%{name}/iscsid_conf_update.sh || :

# Note: Note addition to fstab
%{_prefix}/lib/%{name}/fstab_note.sh || :

# Enable/disable/Mask systemd services
/bin/systemctl --no-reload preset oci-yum-repo-mapper.service  >/dev/null 2>&1 || :
/bin/systemctl --no-reload preset iscsi-boot-volume.service  >/dev/null 2>&1 || :
/bin/systemctl --no-reload preset cpupower.service  >/dev/null 2>&1 || :
if ! dnf group list installed | grep -q Minimal; then
        /bin/systemctl enable nfs_client_id.service  >/dev/null 2>&1 || :
fi
/bin/systemctl mask ctrl-alt-del.target  >/dev/null 2>&1 || :

# Authselect: Create OCI configured profile
if ! authselect list | grep -q "custom/oci-default"; then
	authselect create-profile oci-default -b sssd  >/dev/null 2>&1 || :
fi

# Password: Perform various password related activities
%{_prefix}/lib/%{name}/passwd_mgmt.sh $1 || :

cp -f /etc/authselect/system-auth /etc/authselect/custom/oci-default/
cp -f /etc/authselect/password-auth /etc/authselect/custom/oci-default/

# Apply custom profile
authselect select custom/oci-default --force  >/dev/null 2>&1 || :
authselect apply-changes  >/dev/null 2>&1 || :

# Enable auto-hide for grub-menu
/bin/grub2-editenv - set menu_auto_hide=1
/usr/sbin/grub2-set-bootflag boot_success

# Start/Restart services, rebuild rescue kernel on updates.
if [ "$1" = 2 ]; then
	/bin/systemctl restart rsyslog.service
	/bin/systemctl restart oci-yum-repo-mapper.service
	/bin/systemctl start nfs_client_id.service

	# Revert boot optimization created changes
	if grubby --info DEFAULT | grep -q "netroot=iscsi" ; then
                if ! grubby --info DEFAULT | grep -q "rd.luks=0 rd.md=0 rd.dm=0" ; then
			grubby --update-kernel ALL --args "rd.luks=0 rd.md=0 rd.dm=0"
		fi
		# Since cmdline iscsi args are present, not a minimal image. Safe to remove
		/bin/rm -f /usr/lib/dracut/dracut.conf.d/99-oci-omit-mods.conf
	fi

	# Remove boot optimization added services
	if [ -f %{_sysconfdir}/systemd/system/launch-ldconfig.service ]; then
		/bin/rm -f %{_sharedstatedir}/%{name}/ldconfig-unmasked
		/bin/systemctl disable launch-ldconfig.service >/dev/null 2>&1 || :
		/bin/systemctl unmask ldconfig.service >/dev/null 2>&1 || :
	fi
fi

%triggerin -- selinux-policy-targeted > 38.1
%{_prefix}/lib/%{name}/olc_selinux_update.sh install oci-dhclient || :
%triggerin -- pcp-selinux
%{_prefix}/lib/%{name}/olc_selinux_update.sh install oci-pcp || :

#udev: Update devices' max_retries that are already present in the system.
%{_prefix}/lib/%{name}/updatemaxretries.sh >/dev/null 2>&1 || :

%posttrans
# Create symbolic link of oci.sh for cloud-init
%{__ln_s} -f %{_prefix}/lib/%{name}/cloud/scripts/per-instance/oci.sh %{_sharedstatedir}/cloud/scripts/per-instance/oci.sh
%{__ln_s} -f %{_prefix}/lib/%{name}/cloud/scripts/per-boot/oci.sh %{_sharedstatedir}/cloud/scripts/per-boot/oci.sh

# Since this package installs sysctl and dracut configuration files,
# we need to re-generate the initramfs
#
# We only want to re-generate the initramfs for a fully booted
# system, so /run/systemd/system should exist.
#
# Also check that the running kernel is actually installed:
# We use the presence of symvers file as an indicator, the check is similar
# to what weak-modules script does.
if [ -d /run/systemd/system -a -e "/lib/modules/$(uname -r)/symvers.gz" ]; then
    dracut --verbose --force --no-hostonly >/dev/null 2>&1 || :
fi

%preun

%postun
# We also want to re-generate the initramfs on uninstall
if [ "$1" = 0 ]; then
    # Remove cloud-init symbolic links
    rm -f %{_sharedstatedir}/cloud/scripts/per-instance/oci.sh
    rm -f %{_sharedstatedir}/cloud/scripts/per-boot/oci.sh
    if [ -d /run/systemd/system -a -e "/lib/modules/$(uname -r)/symvers.gz" ]; then
        dracut --verbose --force --no-hostonly >/dev/null 2>&1 || :
    fi
fi


%changelog
* Mon Mar 31 2025 Edgar Granados <edgar.granados.onate@oracle.com> - 2.0-1.0.14
- Update OCI selinux policies for denials seen with oci-dhclient [Orabug: 37697263]
- Add custom authselect profile to apply OCI configurations [Orabug: 37639502]

* Fri Feb 7 2025 Rajesh Harekal <rajesh.harekal@oracle.com> - 2.0-1.0.13
- Update netroot boot cmdline arguments and dracut arg fixes [Orabug: 37545614]

* Thu Nov 7 2024 Rajesh Harekal <rajesh.harekal@oracle.com> - 2.0-1.0.12
- Revert boot optimizations due to regression [Orabug: 37260233]

* Mon Sep 23 2024 Rajesh Harekal <rajesh.harekal@oracle.com> - 2.0-1.0.11
- Skip iscsi boot optimizations on minimal instance [Orabug: 37018765]

* Mon Sep 16 2024 Rajesh Harekal <rajesh.harekal@oracle.com> - 2.0-1.0.10
- Fix launch-ldconfig systemd service file path typo [Orabug: 37066810]

* Wed Aug 21 2024 Rajesh Harekal <rajesh.harekal@oracle.com> - 2.0-1.0.9
- Optimize boot via boot cmdline and initramfs changes. [Orabug: 37010661]

* Fri Mar 29 2024 Jesse Gordon <jesse.gordon@oracle.com> - 2.0-1.0.8
- Consistent path incorrectly linked for multipath enabled UHP attachments [Orabug: 36421446]

* Mon Feb 12 2024 Edgar Granados <edgar.granados.onate@oracle.com> - 2.0-1.0.7
- Reorder PAM faillock.so module to allow LDAP and AD authentication [Orabug: 36164108]

* Thu Jan 11 2024 Edgar Granados <edgar.granados.onate@oracle.com> - 2.0-1.0.6
- Update oci-yum-repo-mapper to support self-service DNS hostnames [Orabug: 36179261]

* Tue Nov 28 2023 Rajesh Harekal <rajesh.harekal@oracle.com> - 2.0-1.0.5
- Randomize cron times for ksplice and uptrack accesses. [Orabug: 35994885]

* Thu Aug 24 2023 Edgar Granados <edgar.granados.onate@oracle.com> - 2.0-1.0.4
- Add new udev rule and changes needed to update max_retries [Orabug: 35592187]
- Update oci-dhclient to prevent removal of IPv4/IPv6 loopback entries in /etc/hosts. [Orabug: 35592141] 

* Thu Jun 08 2023 Rajesh Harekal <rajesh.harekal@oracle.com> - 2.0-1.0.3
- Drop selinux module uninstalls during rpm uninstalls. [Orabug: 35475978] 

* Mon May 08 2023 Rajesh Harekal <rajesh.harekal@oracle.com> - 2.0-1.0.2
- Add OCI selinux policies for denials in oci-dhclient. [Orabug: 35122624] 
- Add OCI selinux policies for denials in pcp. [Orabug: 35310907] 

* Fri Feb 10 2023 Edgar Granados <edgar.granados.onate@oracle.com> - 2.0-1.0.1
- Disable SSH password authentication within the 99_oci.cfg file. [Orabug: 35074453] 

* Mon Jun 06 2022 Rajesh Harekal <rajesh.harekal@oracle.com> - 2.0-1
- Re-factored OL9 OCI image configuration content with new tar source. [Orabug: 34187567]
